import { CaveBase } from "@cave/base";
import type { AjaxOptions, DataType, HttpMethod, ParamType, QueryType } from "./types";
export declare const supportsAbort: boolean;
export declare class CommonAjax<P = any> extends CaveBase<AjaxOptions, RequestInit> {
    #private;
    constructor();
    initDefault(): this;
    timeout(timeout: number): this;
    cancel(cancelled: boolean): this;
    get controller(): AbortController;
    setAbortable(): this;
    abort(force?: boolean): this;
    group(group: string): this;
    param(params?: ParamType, overwrite?: boolean): this;
    getParam(): ParamType;
    payload(payload?: Partial<P>, overwrite?: boolean): this;
    getPayload(): P;
    query(query?: QueryType, overwrite?: boolean): this;
    getQuery(): QueryType;
    method(method: HttpMethod): this;
    mode(mode: RequestMode): this;
    headers(headers: HeadersInit): this;
    baseUrl(baseUrl: string): this;
    getUrl(): string;
    dataType(dataType: DataType): this;
    useCache(useCache: boolean): this;
    cacheName(cacheName: string): this;
    json(): this;
    text(): this;
    blob(): this;
    arrayBuffer(): this;
    formData(): this;
    getCacheKey(): string;
    protected getResponseCache(cacheKey: string): Promise<unknown>;
    protected cacheResponse(res: Response, cacheKey: string): Promise<void>;
    getFullUrl(): string;
    getAjaxUrl(): string;
    protected processParam(): this;
    protected processQuery(): this;
    protected isAbsoluteUrl(url: string): boolean;
}
export declare function isPlainObject(obj: unknown): boolean;
